/*ULMBDO02.C****************************************************************

File:                         ULMBDO02.C

Library Call Demonstrated:		cbDBitOut() for MetraBus Cards

Purpose:						Writes a bit to a digital output port.

Demonstration:					Writes a value to FIRSTPORTA 

Other Library Calls:			cbErrHandling()

Special Requirements:			MetraBus digital output card must be installed


Copyright (c) 1995-2002, Measurement Computing Corp.
All Rights Reserved.
***************************************************************************/


/* Include files */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <time.h>
#include <windows.h>
#include ".\cbw.h"


/* Prototypes */
void ClearScreen (void);
void GetTextCursor (int *x, int *y);
void MoveCursor (int x, int y);
BOOL ask();
int getNewBoardNumber(int col, int row);

double timetic=(double)(CLOCKS_PER_SEC);


char cfg_name[21]="circle1.cfg";



double harm_delay(long delay0) {

   long j;
   double sum;


      sum=0.0;

      for (j=1; j<=delay0; j++) {
         sum=sum+1.0/(double)(j);
      } /* for j */

      return(sum);

} /* harm_delay */


void main() {

	/* Variable Declarations */

	int Row, Col;
	int BoardNum = 0;
	int ULStat = 0;
	int PortNum, Direction;
	WORD DataValue;
	int BitLevel;
	int BitNum;
	WORD BitValue;
	int hilo;
	float    RevLevel = (float)CURRENTREVNUM;
	char s[32];  // string for user input

	long j, n, d0, d1, x1, y1, flag1;

	double sum0;

	char cc;

	double pi1 = 3.14159265358979323;


	/* Declare UL Revision Level */

	ULStat = cbDeclareRevision(&RevLevel);

	/* Initiate error handling

		Parameters:
			PRINTALL :all warnings and errors encountered will be printed
			DONTSTOP :program will continue even if error occurs.
					 Note that STOPALL and STOPFATAL are only effective in
					 Windows applications, not Console applications.
   */

	cbErrHandling(PRINTALL, DONTSTOP);

	/* set up the display screen */

	/*
	ClearScreen();
	*/

	/* specify the port number */

	PortNum = FIRSTPORTA;
	Direction = DIGITALOUT;
	ULStat = cbDConfigPort(BoardNum, PortNum, Direction);


	/* get a user value to write to the port */

	DataValue = 8;


	/* write BitValue to BitNum of FIRSTPORTA

		Parameters:
			BoardNum    :the number used by CB.CFG to describe this board
			PortNum     :must be FIRSTPORTA
			BitNum      :the number of the bit to be set to BitValue
			BitValue    :the value written to the port   */

	for (j = 0; j <= 7; j++) {

	   BitNum = j;
	   BitValue = 0;

	   ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

    } /* for j */

	BitNum = 2;
	BitValue = 1;

	ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

	BitNum = 5;
	BitValue = 1;

	ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

	printf("\nUse the keys a z and , . to run the stepper motors 100 steps at the time.\n\n");
	printf("Quit program by pressing p.\n\n");

	d0 = 10000;
	d1 = 10;

	n = 100;

	x1 = 0;
	y1 = 0;

	sum0 = 0.0;

	printf("%8d %8d\n\n", y1, x1);

	cc = '1';
	flag1 = 0;

	while (flag1 == 0) {

		if (_kbhit()) {
			cc = getch();
		} /* if */

		if (cc == 'a') {

			BitNum = 1;
			BitValue = 1;

			ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			for (j = 1; j <= n; j++) {

				BitNum = 0;
				BitValue = 1;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

				Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 0;
				BitValue = 0;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			    Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				y1--;

			} /* for j */

			printf("%8d %8d\n",x1, y1);

		} /* if */
		
		if (cc == 'z') {

			BitNum = 1;
			BitValue = 0;

			ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			for (j = 1; j <= n; j++) {

				BitNum = 0;
				BitValue = 1;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

				Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 0;
				BitValue = 0;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			    Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				y1++;

			} /* for j */

			printf("%8d %8d\n", x1, y1);


		} /* if */


		if (cc == '.') {

			BitNum = 4;
			BitValue = 1;

			ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			for (j = 1; j <= n; j++) {


				BitNum = 3;
				BitValue = 1;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

				Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 3;
				BitValue = 0;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			    Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				x1--;

			} /* for j */

			printf("%8d %8d\n", x1, y1);

		} /* if */
		
		if (cc == ',') {

			BitNum = 4;
			BitValue = 0;

			ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			for (j = 1; j <= n; j++) {

				BitNum = 3;
				BitValue = 1;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

				Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 3;
				BitValue = 0;

				ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

			    Sleep(1);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				x1++;

			} /* for j */

			printf("%8d %8d\n", x1, y1);

        } /* if */

		if (cc == 'p') {
			flag1 = 1;
		} /* if */

		cc = '1';

    } /* while */


	BitNum = 2;
	BitValue = 0;

	ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

	BitNum = 5;
	BitValue = 0;

	ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

	for (j = 0; j <= 7; j++) {

		BitNum = j;
		BitValue = 0;

		ULStat = cbDBitOut(BoardNum, PortNum, BitNum, BitValue);

	} /* for j */

    printf("\n%12.5f\n",sum0);


    } /* End program */





/***************************************************************************
*
* Name:      reportCurrentBoardNumber(int boardNum)
* Arguments: boardNum - boardNumber
* Returns:   nothing
*
* Queries user and returns the selected board number
*
***************************************************************************/
void reportCurrentBoardNumber(int boardNum)
{
    int c,r;
	GetTextCursor(&c,&r);
	MoveCursor(0,2);
	printf("Currently selected board number is %i.   ",boardNum);
	MoveCursor(c,r);
}

/***************************************************************************
*
* Name:      getNewBoardNumber(int col, int row)
* Arguments: screen position: col = column, row
* Returns:   number from 0 to 63
*
* Queries user and returns the selected board number
*
***************************************************************************/
int getNewBoardNumber(int col, int row)
{
	int bdNum = -1;
	char s[32];
	do
	{
        MoveCursor (col, row);
		printf("Enter new board number -->                        ");
        MoveCursor (col+32, row);
		gets(s);
		sscanf(s,"%i",&bdNum);
	}
	while ((bdNum<0) || (bdNum>64));
	return bdNum;
}

/***************************************************************************
*
* Name:      ask(char *question)
* Arguments: char *question
* Returns:   TRUE if user responds y, FALSE otherwise
*
* Queries user for yes or no response
*
***************************************************************************/

BOOL ask(char *question)
{
   BOOL retval = FALSE;
   char response;
   printf(question);
   response = (char)getchar();
   switch (response)
   {
     case 'y' :
     case 'Y' : retval = TRUE;
   }
   printf("\n\n");
   return retval;
}


/***************************************************************************
*
* Name:      ClearScreen
* Arguments: ---
* Returns:   ---
*
* Clears the screen.
*
***************************************************************************/

#define BIOS_VIDEO   0x10

void
ClearScreen (void)
{
	COORD coordOrg = {0, 0};
	DWORD dwWritten = 0;
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	if (INVALID_HANDLE_VALUE != hConsole)
		FillConsoleOutputCharacter(hConsole, ' ', 80 * 50, coordOrg, &dwWritten);

	MoveCursor(0, 0);

    return;
}


/***************************************************************************
*
* Name:      MoveCursor
* Arguments: x,y - screen coordinates of new cursor position
* Returns:   ---
*
* Positions the cursor on screen.
*
***************************************************************************/


void
MoveCursor (int x, int y)
{
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

	if (INVALID_HANDLE_VALUE != hConsole)
	{
		COORD coordCursor;
		coordCursor.X = (short)x;
		coordCursor.Y = (short)y;
		SetConsoleCursorPosition(hConsole, coordCursor);
	}

    return;
}


/***************************************************************************
*
* Name:      GetTextCursor
* Arguments: x,y - screen coordinates of new cursor position
* Returns:   *x and *y
*
* Returns the current (text) cursor position.
*
***************************************************************************/

void
GetTextCursor (int *x, int *y)
{
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFO csbi;

	*x = -1;
	*y = -1;
	if (INVALID_HANDLE_VALUE != hConsole)
	{
		GetConsoleScreenBufferInfo(hConsole, &csbi);
		*x = csbi.dwCursorPosition.X;
		*y = csbi.dwCursorPosition.Y;
	}

    return;
}





